/* $Id: convert.c,v 1.9 1997/06/19 17:12:27 phil Exp $ */

/*
 * convert from strings to numbers using strto[ld]
 * strto[ld] are in SVID2, XPG2, XPG3, ANSI C
 */

#include "h.h"
#include "snotypes.h"
#include "macros.h"

#include "equ.h"			/* for I and R */
#include "res.h"
#include "data.h"

int
spcint(dp, sp)
    struct descr *dp;
    struct spec *sp;
{
    char buffer[64];			/* ??? */
    int_t len;
    char *cp;
    int_t temp;

    len = S_L(sp);
    cp = S_SP(sp);

    if (D_A(SPITCL)) {			/* SPITBOL features? */
	/* strip leading whitespace */
	while (len > 0 && (*cp == ' ' || *cp == '\t')) {
	    cp++;
	    len--;
	}
    }

    if (len > sizeof(buffer)-1)
	len = sizeof(buffer)-1;
    bcopy( cp, buffer, len );
    buffer[len] = '\0';

    temp = strtol( buffer, &cp, 10);	/* always decimal */
    if (*cp)
	return FALSE;			/* failure */

    D_A(dp) = temp;
    D_F(dp) = 0;			/* clear flags */
    D_V(dp) = I;			/* set type */

    return TRUE;			/* success */
}

int
spreal(dp, sp)
    struct descr *dp;
    struct spec *sp;
{
    char buffer[64];			/* ??? */
    int len;
    char *cp;
    float temp;
    double strtod();

    len = S_L(sp);
    cp = S_SP(sp);

    if (D_A(SPITCL)) {			/* SPITBOL features? */
	/* strip leading whitespace */
	while (len > 0 && (*cp == ' ' || *cp == '\t')) {
	    cp++;
	    len--;
	}
    }

    if (len > sizeof(buffer)-1)
	len = sizeof(buffer)-1;
    bcopy( cp, buffer, len );
    buffer[len] = '\0';

    temp = strtod( buffer, &cp );
    if (*cp)
	return FALSE;			/* failure */

    D_RV(dp) = temp;
    D_F(dp) = 0;			/* clear flags */
    D_V(dp) = R;			/* set type */

    return TRUE;			/* success */
}
