/* $Id: convert.c,v 1.9 1997/05/22 05:05:01 phil Exp $ */

/*
 * convert from strings to numbers.
 *
 * generic version (using scanf or ato[ld] rather than superior strto[ld])
 * use of sscanf() is preferable to ato[ld] since it allows us to detect
 * whether we've matched the whole string.
 */

#include "h.h"
#include "snotypes.h"
#include "macros.h"
#include "equ.h"			/* for I and R */
#include "res.h"
#include "data.h"			/* for SPITCL */

#ifdef NO_SCANF
long atol();
double atof();
#define EXTRA 1				/* NUL, no terminator */
#else
#define TC '|'
#define EXTRA 2				/* NUL + terminator */
#endif

int
spcint(dp, sp)
    struct descr *dp;
    struct spec *sp;
{
    char buffer[64];			/* ??? */
    int_t len;
    char *cp;
#ifndef NO_SCANF
    long l;
    char t;
#endif /* NO_SCANF not defined */

    len = S_L(sp);
    cp = S_SP(sp);

    if (D_A(SPITCL)) {			/* SPITBOL features? */
	/* strip leading whitespace */
	while (len > 0 && (*cp == ' ' || *cp == '\t')) {
	    cp++;
	    len--;
	}
    }

    if (len == 0) {
	D_A(dp) = 0;
	D_F(dp) = 0;			/* clear flags */
	D_V(dp) = I;			/* set type */
	return TRUE;
    }

    if (len > sizeof(buffer)-EXTRA)
	len = sizeof(buffer)-EXTRA);

    bcopy( cp, buffer, len );

#ifdef NO_SCANF
    buffer[len] = '\0';
    D_A(dp) = atol(buffer);
#else  /* NO_SCANF not defined */
    buffer[len++] = TC;
    buffer[len] = '\0';
    if (sscanf(buffer, "%ld%c", &l, &t) != 2 || t != TC)
	return FALSE;
    D_A(dp) = l;
#endif /* NO_SCANF not defined */
    D_F(dp) = 0;			/* clear flags */
    D_V(dp) = I;			/* set type */

    return TRUE;			/* success */
}

int
spreal(dp, sp)
    struct descr *dp;
    struct spec *sp;
{
    char buffer[64];			/* ??? */
    int len;
    char *cp;
#ifndef NO_SCANF
    double d;
    char t;
#endif /* SCANF defined */

    len = S_L(sp);
    cp = S_SP(sp);

    if (D_A(SPITCL)) {			/* SPITBOL features? */
	/* strip leading whitespace */
	while (len > 0 && (*cp == ' ' || *cp == '\t')) {
	    cp++;
	    len--;
	}
    }

    if (len == 0) {
	D_RV(dp) = 0.0;
	D_F(dp) = 0;			/* clear flags */
	D_V(dp) = R;			/* set type */
	return TRUE;
    }

    if (len > sizeof(buffer)-EXTRA)
	len = sizeof(buffer)-EXTRA);

    bcopy( cp, buffer, len );
#ifdef NO_SCANF
    buffer[len] = '\0';
    D_RV(dp) = atof(buffer);
#else  /* NO_SCANF not defined */
    buffer[len++] = TC;
    buffer[len] = '\0';
    if (sscanf(buffer, "%lf%c", &d, &t) != 2 || t != TC)
	return FALSE;
    D_RV(dp) = d;
#endif /* NO_SCANF not defined */
    D_F(dp) = 0;			/* clear flags */
    D_V(dp) = R;			/* set type */

    return TRUE;			/* success */
}
